;Patch by Sadiztyk Fish aka Scyzer
;	Bugfix update 3-23-22: fixed two bugs in the zebetite shot AI.
;	Update by PJBoy.

LoRom
;Header
!Y = ",Y"
!Bank = $A3
!GFXLocation = $AFEC00

org $A0F800			;<-- what the enemy header will be
	DW $0400,#ZebetitePalette,$7FFF,$0000,$0000,$0000
	DB !Bank,$00,$00,$00,$00,$00
	DW #ZebetiteInitAI,$0001,$0000,#ZebetiteRunAI,$800A,$804C,$8041,$0000,$0000
	DW $0000,$0000,$0000,$0000,$0000,$0000,#ZebetiteTouchAI,#ZebetiteShotAI,$0000
	DL !GFXLocation		;<-- location of GFX
	DB $00
	DW $0000,$0000,$0000

;Special = XXX0 / XXX1 for Vertical / Horizontal
;Orientation = HP for this Zebetite
;Speed = XXYY
;	XX = Damage
;	YY = How fast Zebetite restores HP
;Speed2 = Event bit #
	
;0FA8 = Max HP
;0FAA = Regen HP

org $A3F311		;Repoint to free space in an enemy bank
ZebetitePalette:
	DW $3800,$5739,$4273,$2DAD,$14C6,$19DA,$1174,$0D0F
	DW $08AA,$0FDE,$02DF,$019F,$005F,$0037,$6FDF,$0006
{
ZebetiteTileMapV1: DW $0001,ZebetiteStructureV1,$812F
ZebetiteTileMapV2: DW $0001,ZebetiteStructureV2,$812F
ZebetiteTileMapV3: DW $0001,ZebetiteStructureV3,$812F
ZebetiteTileMapV4: DW $0001,ZebetiteStructureV4,$812F
ZebetiteTileMapV5: DW $0001,ZebetiteStructureV5,$812F
ZebetiteTileMapV6: DW $0001,ZebetiteStructureV6,$812F
ZebetiteTileMapH1: DW $0001,ZebetiteStructureH1,$812F
ZebetiteTileMapH2: DW $0001,ZebetiteStructureH2,$812F
ZebetiteTileMapH3: DW $0001,ZebetiteStructureH3,$812F
ZebetiteTileMapH4: DW $0001,ZebetiteStructureH4,$812F
ZebetiteTileMapH5: DW $0001,ZebetiteStructureH5,$812F
ZebetiteTileMapH6: DW $0001,ZebetiteStructureH6,$812F

ZebetiteStructureV1: DW $0003
	DW $0000,$FFF0,VMap1,ZebetiteHitbox
	DW $0000,$0000,VMap1,ZebetiteHitbox
	DW $0000,$0010,VMap1,ZebetiteHitbox
ZebetiteStructureH1: DW $0003
	DW $FFF0,$0000,HMap1,ZebetiteHitbox
	DW $0000,$0000,HMap1,ZebetiteHitbox
	DW $0010,$0000,HMap1,ZebetiteHitbox

ZebetiteStructureV2: DW $0003
	DW $0000,$FFF0,VMap2,ZebetiteHitbox
	DW $0000,$0000,VMap2,ZebetiteHitbox
	DW $0000,$0010,VMap2,ZebetiteHitbox
ZebetiteStructureH2: DW $0003
	DW $FFF0,$0000,HMap2,ZebetiteHitbox
	DW $0000,$0000,HMap2,ZebetiteHitbox
	DW $0010,$0000,HMap2,ZebetiteHitbox

ZebetiteStructureV3: DW $0003
	DW $0000,$FFF0,VMap3,ZebetiteHitbox
	DW $0000,$0000,VMap3,ZebetiteHitbox
	DW $0000,$0010,VMap3,ZebetiteHitbox
ZebetiteStructureH3: DW $0003
	DW $FFF0,$0000,HMap3,ZebetiteHitbox
	DW $0000,$0000,HMap3,ZebetiteHitbox
	DW $0010,$0000,HMap3,ZebetiteHitbox

ZebetiteStructureV4: DW $0003
	DW $0000,$FFF0,VMap4,ZebetiteHitbox
	DW $0000,$0000,VMap4,ZebetiteHitbox
	DW $0000,$0010,VMap4,ZebetiteHitbox
ZebetiteStructureH4: DW $0003
	DW $FFF0,$0000,HMap4,ZebetiteHitbox
	DW $0000,$0000,HMap4,ZebetiteHitbox
	DW $0010,$0000,HMap4,ZebetiteHitbox

ZebetiteStructureV5: DW $0003
	DW $0000,$FFF0,VMap5,ZebetiteHitbox
	DW $0000,$0000,VMap5,ZebetiteHitbox
	DW $0000,$0010,VMap5,ZebetiteHitbox
ZebetiteStructureH5: DW $0003
	DW $FFF0,$0000,HMap5,ZebetiteHitbox
	DW $0000,$0000,HMap5,ZebetiteHitbox
	DW $0010,$0000,HMap5,ZebetiteHitbox

ZebetiteStructureV6: DW $0003
	DW $0000,$FFF0,VMap6,ZebetiteHitbox
	DW $0000,$0000,VMap6,ZebetiteHitbox
	DW $0000,$0010,VMap6,ZebetiteHitbox
ZebetiteStructureH6: DW $0003
	DW $FFF0,$0000,HMap6,ZebetiteHitbox
	DW $0000,$0000,HMap6,ZebetiteHitbox
	DW $0010,$0000,HMap6,ZebetiteHitbox
	
ZebetiteHitbox: DW $0001
	DW $FFF7,$FFF7,$0009,$0009,ZebetiteTouchAI,ZebetiteShotAI
VMap1: DW $0001
	DB $F8,$81,$F8,$00,$21
VMap2: DW $0001
	DB $F8,$81,$F8,$02,$21
VMap3: DW $0002
	DB $FC,$01,$F8,$04,$21
	DB $FC,$01,$00,$14,$21
VMap4: DW $0002
	DB $FC,$01,$F8,$05,$21
	DB $FC,$01,$00,$15,$21
VMap5: DW $0002
	DB $FC,$01,$F8,$06,$21
	DB $FC,$01,$00,$16,$21
VMap6: DW $0002
	DB $FC,$01,$F8,$07,$21
	DB $FC,$01,$00,$17,$21
HMap1: DW $0001
	DB $F8,$81,$F8,$08,$21
HMap2: DW $0001
	DB $F8,$81,$F8,$0A,$21
HMap3: DW $0002
	DB $F8,$01,$FC,$0C,$21
	DB $00,$00,$FC,$0D,$21
HMap4: DW $0002
	DB $F8,$01,$FC,$1C,$21
	DB $00,$00,$FC,$1D,$21
HMap5: DW $0002
	DB $F8,$01,$FC,$0E,$21
	DB $00,$00,$FC,$0F,$21
HMap6: DW $0002
	DB $F8,$01,$FC,$1E,$21
	DB $00,$00,$FC,$1F,$21
ZebetiteTM1: DW ZebetiteTileMapV1,ZebetiteTileMapH1
ZebetiteTM2: DW ZebetiteTileMapV2,ZebetiteTileMapH2
ZebetiteTM3: DW ZebetiteTileMapV3,ZebetiteTileMapH3
ZebetiteTM4: DW ZebetiteTileMapV4,ZebetiteTileMapH4
ZebetiteTM5: DW ZebetiteTileMapV5,ZebetiteTileMapH5
ZebetiteTM6: DW ZebetiteTileMapV6,ZebetiteTileMapH6

ZebetiteSize: DW $0008,$0018,$0018,$0008
ZebetiteTMTable:
	DW ZebetiteTM1
	DW ZebetiteTM2
	DW ZebetiteTM3
	DW ZebetiteTM4
	DW ZebetiteTM5
	DW ZebetiteTM6
}

ZebetiteInitAI: LDX $0E54
	LDA $0FB6,X : BEQ SetupZebetite : DEC A : JSL $80818E
	LDA $7ED820,X : BIT $05E7 : BEQ SetupZebetite
		LDX $0E54 : STZ $0F78,X : RTL
	SetupZebetite: LDX $0E54
	LDA $0F86,X : ORA #$B000 : STA $0F86,X
	LDA $0F88,X : ORA #$0004 : STA $0F88,X
	LDA $0F92,X : STA $0F8C,X : STA $0FA8,X
	LDA $0FB4,X : AND #$00FF : STA $0FAA,X
	LDA $0F86,X : AND #$0001 : ASL A : TAY : LDA ZebetiteTM1!Y : STA $0F92,X
		TYA : ASL A : TAY
		LDA ZebetiteSize!Y : STA $0F82,X : LDA ZebetiteSize+2!Y : STA $0F84,X
	RTL
ZebetiteRunAI: LDX $0E54
	LDA $0F8C,X : CLC : ADC $0FAA,X : CMP $0FA8,X : BCC $03 : LDA $0FA8,X : STA $0F8C,X
	LDA $0FA8,X : STA $4204 : SEP #$20 : LDA #$06 : STA $4206 : PHA : PLA : PHA : PLA : REP #$20
		LDA $4214 : STA $00 : CLC : ADC $4214 : STA $02 : ADC $4214 : STA $04 : ADC $4214 : STA $06 : ADC $4214 : STA $08
	STZ $10 : LDA $0F8C,X
	CMP $08 : BCS LoadZebetiteTM : INC $10
	CMP $06 : BCS LoadZebetiteTM : INC $10
	CMP $04 : BCS LoadZebetiteTM : INC $10
	CMP $02 : BCS LoadZebetiteTM : INC $10
	CMP $00 : BCS LoadZebetiteTM : INC $10
LoadZebetiteTM:
	LDA $10 : ASL A : TAY : LDA ZebetiteTMTable,Y : STA $12 : SEP #$20 : LDA #!Bank : STA $14 : REP #$20
		LDA $0F86,X : AND #$0001 : ASL A : TAY
		LDA [$12],Y : STA $0F92,X : LDA #$0001 : STA $0F94,X : RTL 
ZebetiteShotAI: LDX $0E54
	LDA $18A6 : ASL A : TAY
	LDA $0C18,Y : AND #$0300 : CMP #$0100 : BEQ +
							   CMP #$0200 : BEQ + : JMP $802D
+	LDA $0F8C,X : SEC : SBC $0C2C,Y : BCC KillZebetite
		STA $0F8C,X : LDA #$0008 : STA $0F9C,X
		LDA #$0009 : JSL $80914D : RTL
	KillZebetite: LDA $0FB6,X : BEQ EndZebetiteShotAI : DEC A : JSL $80818E
		LDA $7ED820,X : ORA $05E7 : STA $7ED820,X
	EndZebetiteShotAI: LDX $0E54 : LDA #$0004 : JSL $A0A3AF : RTL
ZebetiteTouchAI: LDX $0E54
	LDA $0FB4,X : AND #$FF00 : LSR #4 : STA $0A4F
	EndZebetiteTouchAI: RTL